书籍龙与地下城游戏问题(4)0527

题目:

给定一个二维数组map。含义是一张地图,例如,如下矩阵:

-2 -3 3

-5 -10 1

0 30 -5

游戏的规则如下:

骑士从左上角出发,每次只能向右或向下走,最后到达右下角见到公主。

地图中每个位置的值代表骑士要遭遇的事情,如果是负数,说明此处有怪兽,要让骑士损失血量。如果是非负数,代表此处有血瓶,能让骑士回血。

骑士从左上角到右下角的过程中,走到任何一个位置时,血量都不能少于1。

为了保证骑士能见到公主,初始血量至少是多少?根据map,返回初始血量。

定义和地图代傲一样的矩阵,记为dp,dpij的含义是如果骑士要走上位置(i,j),并且从该位置选一条最优的路径,最后走到右下角,骑士起码应该具备的血量。根据dp的定义,我们最终需要的是dp00的结果。

dpij有两个选择向右或者是向下。

java 复制代码
public int minHP1(int[][] m){
    if(m == null || m.length ==  0 || m[0] == null || m[0].length == 0){
        return 1;
    }
    //因为整体要算dp[0][0]的值,所以计算初始化最后一行所有的列的值,循环的时候从
    //最后一行开始就行
    int row = m.lenght;
    int col = m[0].length;
    int[][] dp = new int[row--][col--];
    //下面的row和col已经做了减减处理
    dp[row][col] = m[row][col] > 0 ? 1 : -m[row][col] + 1;
    for(int j = col -1; j>=0;j--){
      dp[row][j] = Math.max(dp[row][j+1] - m[row][j],1);  
    }
    int right = 0;
    int down = 0;
    for(int i = row -1;i>=0;i--){
        dp[i][col] = Math.max(dp[i+1][col] - m[i][col],1);
        for(int j=col-1;j>=0;j--){
            right = Math.max(dp[i][j+1] - m[i][j],1);
            down = Math.max(dp[i+1][j] - m[i][j],1);
            dp[i][j] = Math.min(right,down);
        }
    }
    return dp[0][0];
}
相关推荐
Navigator_Z1 小时前
LeetCode //C - 1300. Sum of Mutated Array Closest to Target
c语言·算法·leetcode
SZYSK1 小时前
鸿蒙人脸识别算法放在终端里:和外挂授权 SDK 差在排障路径
物联网·算法·华为·harmonyos
Raspberry_Pi_官方账号1 小时前
隆重推出《Raspberry Pi 复古游戏指南》
游戏·树莓派·diy·raspberry pi
凯瑟琳.奥古斯特1 小时前
力扣1016高效解法:剪枝优化技巧
开发语言·c++·算法·leetcode·职场和发展
xiangyun612 小时前
C++ priority_queue 底层:手撕二叉堆与 Top K 问题
c++·算法·面试·stl·1024程序员节
Oiiouui2 小时前
针对Godot-GridGame(网格游戏)的DI注入+RefCounted数据驱动信号流架构设计的研究(全程开源)
游戏·游戏引擎·godot·1024程序员节
qz_Serene3 小时前
练习算法题:双指针 -cpp
c++·算法·leetcode·1024程序员节
Nuanyt3 小时前
Hot 100 刷题笔记 · 数组与哈希专题(3 题)
java·笔记·算法·leetcode·哈希算法·1024程序员节
碧海银沙音频科技研究院3 小时前
基于炬芯平台ATS308X多模型兼容语音识别算法
人工智能·算法·语音识别
爱读书的小胖4 小时前
LeetCode 274 H 指数 C 语言解题分析
c语言·算法·leetcode·1024程序员节